macro_rules ! label { (
	$ ( @ hexpand : $ hexpand : expr , ) ?
	$ ( @ vexpand : $ vexpand : expr , ) ?
	$ ( @ halign : $ halign : expr , ) ?
	$ ( @ valign : $ valign : expr , ) ?
	$ ( $ label : expr ) ? $ (,) ?
) => { {
	let label = gtk4 :: Label :: builder () . build () ;
	$ ( label . set_hexpand ( $ hexpand ) ; ) ?
	$ ( label . set_vexpand ( $ vexpand ) ; ) ?
	$ ( label . set_halign ( $ halign ) ; ) ?
	$ ( label . set_valign ( $ valign ) ; ) ?
	$ ( label . set_label ( $ label ) ; ) ?
	label
} } }

macro_rules ! g_box { (
	$ ( @ orientation : $ orientation : expr , ) ?
	$ ( $ child : expr ) , * $ (,) ?
) => { {
	let container = gtk4 :: Box :: builder () . build () ;
	$ ( container . set_orientation ( $ orientation ) ; ) ?
	$ ( container . append ( $ child ) ; ) *
	container
} } }

macro_rules ! view_stack { (
	$ ( $ title : expr , $ icon : expr , $ widget : expr , ) *
) => { {
	let container = libadwaita :: ViewStack :: new () ;
	$ ( container . add_titled_with_icon ( $ widget , None , $ title , $ icon ) ; ) *
	container
} } }

macro_rules ! list_box { ( $ ( $ child : expr , ) * ) => { {
	let container = gtk4 :: ListBox :: new () ;
	$ ( container . append ( $ child ) ; ) *
	container
} } }

macro_rules ! vertically_filling { ( $ child : expr ) => {
	g_box ! (
		@ orientation : gtk4 :: Orientation :: Vertical ,
		$ child ,
		& libadwaita :: Bin :: builder ()
			. css_name ("filler")
			. vexpand (true)
			. build () ,
	)
} }



pub (crate) use {
	label ,
	g_box ,
	view_stack ,
	list_box ,
	vertically_filling ,
} ;
